﻿using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace HttpClientExample.Controllers
{
    [Produces("application/json")]
    [Route("v1/[controller]")]
    public class ValuesController : Controller
    {
        private readonly HttpClient _httpClient;

        public ValuesController(HttpClient httpClient)
        {
            _httpClient = httpClient;
        }

        [HttpGet]
        public async Task<IActionResult> Get()
        {
            string requestEndpoint = $"numbers/";

            HttpResponseMessage httpResponse = await _httpClient.GetAsync(requestEndpoint);

            if (httpResponse.IsSuccessStatusCode)
            {
                IEnumerable<int> numbers = JsonConvert.DeserializeObject<IEnumerable<int>>(await httpResponse.Content.ReadAsStringAsync());
                return Ok(numbers);
            }

            return StatusCode((int)httpResponse.StatusCode, httpResponse.Content.ReadAsStringAsync());
        }
    }
}
